package it.cnr.iit.iai.utility;

import java.util.HashMap;
import java.util.UUID;
import java.util.concurrent.Future;
import java.util.concurrent.ThreadLocalRandom;

import org.springframework.stereotype.Component;

import it.cnr.iit.analytics.types.AnalyticStructure;
import it.cnr.iit.analytics.types.DpoResponses;

@Component
public class TicketManager {

	// analytic which owns the ticket
	// Starting from the session id, we can retrieve the ticket generated by that
	// session
	private HashMap<String, String> ticketFromSessionId = new HashMap<>();
	private HashMap<String, AnalyticStructure> analyticStructureFromTicket = new HashMap<>();

	public TicketManager() {
	}

	public Future<DpoResponses> getResult(String ticket) throws Exception {
		return (Future<DpoResponses>) analyticStructureFromTicket.get(ticket).getFuture();
	}

	public boolean isTicketPresent(String ticket) throws Exception {
		return analyticStructureFromTicket.containsKey(ticket);
	}

	public String generateUniqueTicket() {
		String ticket = UUID.randomUUID().toString().replace("-", "") + ThreadLocalRandom.current().nextLong();
		if (analyticStructureFromTicket.containsKey(ticket)) {
			return generateUniqueTicket();
		}
		return ticket;
	}

	public void ticketServed(String ticket) throws Exception {
		analyticStructureFromTicket.remove(ticket);
	}

	public String getTicketFromSessionIdHM(String sessionId) {
		return ticketFromSessionId.get(sessionId);
	}

	public void setTicketFromSessionIdHM(String sessionId, String ticket) {
		ticketFromSessionId.put(sessionId, ticket);
	}

	public void removeTicketFromSessionIdHM(String sessionId) {
		ticketFromSessionId.remove(sessionId);
	}

	public HashMap<String, String> getTicketFromSessionIdHM() {
		return ticketFromSessionId;
	}

	public HashMap<String, AnalyticStructure> getAnalyticStructureFromTicket() {
		return analyticStructureFromTicket;
	}

	public void setAnalyticStructureFromTicket(HashMap<String, AnalyticStructure> analyticStructureFromTicket) {
		this.analyticStructureFromTicket = analyticStructureFromTicket;
	}

	public void addAnalyticStructureFromTicket(String ticket, AnalyticStructure analyticStructure) {
		this.analyticStructureFromTicket.put(ticket, analyticStructure);
	}

}
